diff -aruN --binary 1/plugins/editors/tinymce/jscripts/tiny_mce/plugins/tinybrowser/upload_process.php 2/plugins/editors/tinymce/jscripts/tiny_mce/plugins/tinybrowser/upload_process.php
--- 1/plugins/editors/tinymce/jscripts/tiny_mce/plugins/tinybrowser/upload_process.php	2009-06-30 22:05:16.000000000 +0200
+++ 2/plugins/editors/tinymce/jscripts/tiny_mce/plugins/tinybrowser/upload_process.php	2009-07-23 04:25:36.000000000 +0200
@@ -1,99 +1,4 @@
-<?php
-require_once('config_tinybrowser.php');
-require_once('fns_tinybrowser.php');
-
-// delay script if set
-if($tinybrowser['delayprocess']>0) sleep($tinybrowser['delayprocess']);
-
-// Initialise files array and error vars
-$files = array();
-$good = 0;
-$bad = 0;
-$dup = 0;
-$total = (isset($_GET['filetotal']) ? $_GET['filetotal'] : 0);
-
-
-// Assign get variables
-$folder = $tinybrowser['docroot'].urldecode($_GET['folder']);
-$foldernow = urlencode(str_replace($tinybrowser['path'][$_GET['type']],'',urldecode($_GET['folder'])));
-$passfeid = (isset($_GET['feid']) ? '&feid='.$_GET['feid'] : '');
-
-if ($handle = opendir($folder))
-	{
-	while (false !== ($file = readdir($handle)))
-		{
-		if ($file != "." && $file != ".." && substr($file,-1)=='_')
-			{
-			//-- File Naming
-			$tmp_filename = $folder.$file;
-			$dest_filename	 = $folder.rtrim($file,'_');
-        
-			//-- Duplicate Files
-			if(file_exists($dest_filename)) { unlink($tmp_filename); $dup++; continue; }
-
-			//-- Bad extensions
-			$nameparts = explode('.',$dest_filename);
-			$ext = end($nameparts);
-			
-			if(!validateExtension($ext, $tinybrowser['prohibited'])) { unlink($tmp_filename); continue; }
-        
-			//-- Rename temp file to dest file
-			rename($tmp_filename, $dest_filename);
-			$good++;
-			
-			//-- if image, perform additional processing
-			if($_GET['type']=='image')
-				{
-				//-- Good mime-types
-				$imginfo = getimagesize($dest_filename);
-	   		if($imginfo === false) { unlink($dest_filename); continue; }
-				$mime = $imginfo['mime'];
-
-				// resize image to maximum height and width, if set
-				if($tinybrowser['imageresize']['width'] > 0 || $tinybrowser['imageresize']['height'] > 0)
-					{
-					// assign new width and height values, only if they are less than existing image size
-					$widthnew  = ($tinybrowser['imageresize']['width'] > 0 && $tinybrowser['imageresize']['width'] < $imginfo[0] ? $tinybrowser['imageresize']['width'] : $imginfo[0]);
-					$heightnew = ($tinybrowser['imageresize']['height'] > 0 && $tinybrowser['imageresize']['height'] < $imginfo[1] ? $tinybrowser['imageresize']['height'] :  $imginfo[1]);
-
-					// only resize if width or height values are different
-					if($widthnew != $imginfo[0] || $heightnew != $imginfo[1])
-						{
-						$im = convert_image($dest_filename,$mime);
-						resizeimage($im,$widthnew,$heightnew,$dest_filename,$tinybrowser['imagequality'],$mime);
-						imagedestroy($im);
-						}
-					}
-
-				// generate thumbnail
-				$thumbimg = $folder.'_thumbs/_'.rtrim($file,'_');
-				if (!file_exists($thumbimg))
-					{
-					$im = convert_image($dest_filename,$mime);
-					resizeimage	($im,$tinybrowser['thumbsize'],$tinybrowser['thumbsize'],$thumbimg,$tinybrowser['thumbquality'],$mime);
-					imagedestroy ($im);
-					}
-				}
-
-      	}
-		}
-	closedir($handle);
-	}
-$bad = $total-($good+$dup);
-
-// Check for problem during upload
-if($total>0 && $bad==$total) Header('Location: ./upload.php?type='.$_GET['type'].$passfeid.'&permerror=1&total='.$total);
-else Header('Location: ./upload.php?type='.$_GET['type'].$passfeid.'&folder='.$foldernow.'&badfiles='.$bad.'&goodfiles='.$good.'&dupfiles='.$dup);
-?>
-
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
-	<head>
-	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
-	<meta http-equiv="Pragma" content="no-cache" />
-		<title>TinyBrowser :: Process Upload</title>
-	</head>
-	<body>
-		<p>Sorry, there was an error processing file uploads.</p>
-	</body>
-</html>
+<?php
+
+// no direct access
+defined('_JEXEC') or die('Restricted access');
diff -aruN --binary 1/plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.php 2/plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.php
--- 1/plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.php	2009-06-30 22:01:34.000000000 +0200
+++ 2/plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.php	2009-07-23 04:25:36.000000000 +0200
@@ -10,8 +10,6 @@
  * Notice: This script defaults the button_tile_map option to true for extra performance.
  */
 
-	defined('_JEXEC') or die('Restricted access');
-
 	// Set the error reporting to minimal.
 	@error_reporting(E_ERROR | E_WARNING | E_PARSE);
 
diff -aruN --binary 1/plugins/editors/tinymce.php 2/plugins/editors/tinymce.php
--- 1/plugins/editors/tinymce.php	2009-06-30 22:01:34.000000000 +0200
+++ 2/plugins/editors/tinymce.php	2009-07-23 04:25:36.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: tinymce.php 12354 2009-06-24 14:38:24Z ian $
+ * @version		$Id: tinymce.php 12543 2009-07-23 01:47:21Z ian $
  * @package		Joomla
  * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -322,14 +322,6 @@
 			$buttons4[]	= 'template';
 		}
 
-		// tinybrowser
-		$tinybrowser	= $this->params->def( 'tinybrowser', 1 );
-		if ( $tinybrowser ) {
-			$file_browser_callback	= "file_browser_callback : \"tinyBrowser\",";
-		} else {
-			$file_browser_callback	= "";
-		}
-
 		// advimage
 		$advimage = $this->params->def( 'advimage', 1 );
 		if ( $advimage ) {
@@ -535,10 +527,6 @@
 				}
 				});
 				</script>";
-				if ( $tinybrowser ) {
-					$return .="\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tb_tinymce.js.php\"></script>\n";
-					setcookie('tinybrowser_lang', $langPrefix, 0, "/");
-				}
 		  break;
 		}
 
diff -aruN --binary 1/plugins/editors-xtd/image.php 2/plugins/editors-xtd/image.php
--- 1/plugins/editors-xtd/image.php	2009-05-29 14:52:04.000000000 +0200
+++ 2/plugins/editors-xtd/image.php	2009-07-23 04:25:36.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: image.php 11784 2009-04-24 17:34:11Z kdevine $
+ * @version		$Id: image.php 12542 2009-07-22 17:40:48Z ian $
  * @package		Joomla
  * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -49,12 +49,30 @@
 	{
 		global $mainframe;
 		$params =& JComponentHelper::getParams('com_media');
-		$ranks = array('publisher', 'editor', 'author', 'registered');
+		//Find out who has permission to upload and change the acl to let them.
 		$acl = & JFactory::getACL();
-		for($i = 0; $i < $params->get('allowed_media_usergroup', 3); $i++)
+		switch ($params->get('allowed_media_usergroup')) 
 		{
-			$acl->addACL( 'com_media', 'popup', 'users', $ranks[$i] );
+			case '1':
+				$acl->addACL( 'com_media', 'upload', 'users', 'publisher' );
+				break;
+			case '2':
+				$acl->addACL( 'com_media', 'upload', 'users', 'publisher' );
+				$acl->addACL( 'com_media', 'upload', 'users', 'editor' );
+				break;
+			case '3': 
+				$acl->addACL( 'com_media', 'upload', 'users', 'publisher' );
+				$acl->addACL( 'com_media', 'upload', 'users', 'editor' );				
+				$acl->addACL( 'com_media', 'upload', 'users', 'author' );
+				break;								
+			case '4':
+				$acl->addACL( 'com_media', 'upload', 'users', 'publisher' );				
+				$acl->addACL( 'com_media', 'upload', 'users', 'editor' );
+				$acl->addACL( 'com_media', 'upload', 'users', 'author' );
+				$acl->addACL( 'com_media', 'upload', 'users', 'registered' );
+				break;
 		}
+	
 		//Make sure the user is authorized to view this page
 		$user = & JFactory::getUser();
 		if (!$user->authorize( 'com_media', 'popup' )) {
